require '_h2ph_pre.ph';

unless(defined(&_LINUX_SWAP_H)) {
    eval 'sub _LINUX_SWAP_H () {1;}' unless defined(&_LINUX_SWAP_H);
    require 'linux/spinlock.ph';
    require 'asm/page.ph';
    eval 'sub SWAP_FLAG_PREFER () {0x8000;}' unless defined(&SWAP_FLAG_PREFER);
    eval 'sub SWAP_FLAG_PRIO_MASK () {0x7fff;}' unless defined(&SWAP_FLAG_PRIO_MASK);
    eval 'sub SWAP_FLAG_PRIO_SHIFT () {0;}' unless defined(&SWAP_FLAG_PRIO_SHIFT);
    eval 'sub MAX_SWAPFILES () {32;}' unless defined(&MAX_SWAPFILES);
    if(defined(&__KERNEL__)) {
	eval 'sub __swapoffset {
	    local($x) = @_;
    	    eval q(((0)->$x));
	}' unless defined(&__swapoffset);
	eval 'sub MAX_SWAP_BADPAGES () {(( &__swapoffset( ($magic->{magic})) -  &__swapoffset( ($info->{badpages}))) / $sizeof{\'int\'});}' unless defined(&MAX_SWAP_BADPAGES);
	require 'asm/atomic.ph';
	eval 'sub SWP_USED () {1;}' unless defined(&SWP_USED);
	eval 'sub SWP_WRITEOK () {3;}' unless defined(&SWP_WRITEOK);
	eval 'sub SWAP_CLUSTER_MAX () {32;}' unless defined(&SWAP_CLUSTER_MAX);
	eval 'sub SWAP_MAP_MAX () {0x7fff;}' unless defined(&SWAP_MAP_MAX);
	eval 'sub SWAP_MAP_BAD () {0x8000;}' unless defined(&SWAP_MAP_BAD);
	eval 'sub get_swap_page () {
	    eval q( &__get_swap_page(1));
	}' unless defined(&get_swap_page);
	eval 'sub swap_free {
	    local($entry) = @_;
    	    eval q( &__swap_free(($entry), 1));
	}' unless defined(&swap_free);
	eval 'sub SWAP_CACHE_INFO () {1;}' unless defined(&SWAP_CACHE_INFO);
	if(defined(&SWAP_CACHE_INFO)) {
	}
	eval 'sub PAGE_AGE_START () {2;}' unless defined(&PAGE_AGE_START);
	eval 'sub PAGE_AGE_ADV () {3;}' unless defined(&PAGE_AGE_ADV);
	eval 'sub PAGE_AGE_MAX () {64;}' unless defined(&PAGE_AGE_MAX);
	eval 'sub DEBUG_ADD_PAGE () { &if ( &PageActive( &page) ||  &PageInactiveDirty( &page) ||  &PageInactiveClean( &page))  &BUG();;}' unless defined(&DEBUG_ADD_PAGE);
	eval 'sub ZERO_PAGE_BUG () { &if ( &page_count( &page) == 0)  &BUG();;}' unless defined(&ZERO_PAGE_BUG);
	eval 'sub add_page_to_active_list {
	    local($page) = @_;
    	    eval q({  &DEBUG_ADD_PAGE  &ZERO_PAGE_BUG  &SetPageActive($page);  &list_add(($page)-> &lru,  &active_list);  &nr_active_pages++; });
	}' unless defined(&add_page_to_active_list);
	eval 'sub add_page_to_inactive_dirty_list {
	    local($page) = @_;
    	    eval q({  &DEBUG_ADD_PAGE  &ZERO_PAGE_BUG  &SetPageInactiveDirty($page);  &list_add(($page)-> &lru,  &inactive_dirty_list);  &nr_inactive_dirty_pages++;  ($page->{zone}->{inactive_dirty_pages})++; });
	}' unless defined(&add_page_to_inactive_dirty_list);
	eval 'sub add_page_to_inactive_clean_list {
	    local($page) = @_;
    	    eval q({  &DEBUG_ADD_PAGE  &ZERO_PAGE_BUG  &SetPageInactiveClean($page);  &list_add(($page)-> &lru,  ($page->{zone}->{inactive_clean_list}));  ($page->{zone}->{inactive_clean_pages})++; });
	}' unless defined(&add_page_to_inactive_clean_list);
	eval 'sub del_page_from_active_list {
	    local($page) = @_;
    	    eval q({  &list_del(($page)-> &lru);  &ClearPageActive($page);  &nr_active_pages--;  &DEBUG_ADD_PAGE  &ZERO_PAGE_BUG });
	}' unless defined(&del_page_from_active_list);
	eval 'sub del_page_from_inactive_dirty_list {
	    local($page) = @_;
    	    eval q({  &list_del(($page)-> &lru);  &ClearPageInactiveDirty($page);  &nr_inactive_dirty_pages--;  ($page->{zone}->{inactive_dirty_pages})--;  &DEBUG_ADD_PAGE  &ZERO_PAGE_BUG });
	}' unless defined(&del_page_from_inactive_dirty_list);
	eval 'sub del_page_from_inactive_clean_list {
	    local($page) = @_;
    	    eval q({  &list_del(($page)-> &lru);  &ClearPageInactiveClean($page);  ($page->{zone}->{inactive_clean_pages})--;  &DEBUG_ADD_PAGE  &ZERO_PAGE_BUG });
	}' unless defined(&del_page_from_inactive_clean_list);
	eval 'sub INACTIVE_SHIFT () {6;}' unless defined(&INACTIVE_SHIFT);
	eval 'sub inactive_min {
	    local($a,$b) = @_;
    	    eval q((($a) < ($b) ? ($a) : ($b)));
	}' unless defined(&inactive_min);
	eval 'sub inactive_target () { &inactive_min(( &memory_pressure >>  &INACTIVE_SHIFT), ( &num_physpages / 4));}' unless defined(&inactive_target);
	unless(defined(&_LINUX_KDEV_T_H)) {
	    require 'linux/kdev_t.ph';
	}
	unless(defined(&_LINUX_MAJOR_H)) {
	    require 'linux/major.ph';
	}
	eval 'sub page_ramdisk {
	    local($page) = @_;
    	    eval q(( ($page->{buffers})  && ( &MAJOR( ($page->{buffers}->{b_dev})) ==  &RAMDISK_MAJOR)  &&  &buffer_protected( ($page->{buffers}))));
	}' unless defined(&page_ramdisk);
	eval 'sub swap_list_lock () {
	    eval q( &spin_lock( &swaplock));
	}' unless defined(&swap_list_lock);
	eval 'sub swap_list_unlock () {
	    eval q( &spin_unlock( &swaplock));
	}' unless defined(&swap_list_unlock);
	eval 'sub swap_device_lock {
	    local($p) = @_;
    	    eval q( &spin_lock( ($p->{sdev_lock})));
	}' unless defined(&swap_device_lock);
	eval 'sub swap_device_unlock {
	    local($p) = @_;
    	    eval q( &spin_unlock( ($p->{sdev_lock})));
	}' unless defined(&swap_device_unlock);
    }
}
1;
